import sys, time, json, os
import twitter

CONSUMER_KEY = 'KEY HERE'
CONSUMER_SECRET = 'SECRET HERE'

MY_TWITTER_CREDS = os.path.expanduser('~/.my_app_credentials')
if not os.path.exists(MY_TWITTER_CREDS):
    twitter.oauth_dance("Weather Effects", CONSUMER_KEY, CONSUMER_SECRET,
                MY_TWITTER_CREDS)

oauth_token, oauth_secret = twitter.read_token_file(MY_TWITTER_CREDS)

unitedstates = ["-124.7625,24.5210,-66.9326,49.3845","-179.1506, 51.2097, -129.9795, 71.4410","-160.2471, 18.9117, -154.8066, 22.2356"]

starttime = time.time()
while time.time() - starttime < 48*60*60:
    try:
        out = open('twitter/us_' + time.strftime("%Y%m%d%H%M%S") + '.csv','w')

        twitter_stream = twitter.TwitterStream(api_version="1.1", auth=twitter.OAuth(oauth_token, oauth_secret, CONSUMER_KEY, CONSUMER_SECRET))
        stream = twitter_stream.statuses.filter(locations=','.join(unitedstates))

        mystart = time.time()
        total = 0
        for tweet in stream:
            total = total + 1
            if total % 1000 == 0:
                print total
            if not 'text' in tweet:
                continue

            id = tweet['id']
            tstr = time.strftime("%Y-%m-%dT%H:%M:%S", time.strptime(tweet['created_at'], "%a %b %d %H:%M:%S +0000 %Y"))
            user = tweet['user']['screen_name']
            geo = "NA,NA"
            if tweet['geo']:
                geo = str(tweet['geo']['coordinates'][0]) + ',' + str(tweet['geo']['coordinates'][1])
            location = "NA"
            if tweet['place']:
                location = '"' + tweet['place']['full_name'].replace('"', "'") + '"'
            lang = tweet['user']['lang']
            text = '"' + tweet['text'].replace('"', "'") + '"'
            reply = "NA"
            if tweet['in_reply_to_screen_name']:
                reply = tweet['in_reply_to_screen_name']

            out.write((str(id) + ',' + tstr + ',' + user + ',' + geo + ',' + location + ',' + lang + ',' + text + ',' + reply + "\n").encode('utf-8'))

            if time.time() - mystart > 24*60*60:
                break
    except Exception as e:
        print e
        time.sleep(60)
        pass
